/**************************************************************************
 * 
 * Copyright (C) 2011 Nena Innovation AB. All rights reserved.
 * 
 **************************************************************************/


attribute vec4 a_quad_data;
attribute vec4 a_particle_info;

uniform mat4 u_viewProj;
uniform mat4 u_billboard;
uniform vec3 u_quad_coord[4];
uniform vec2 u_quad_tex[4];

uniform vec3 u_eye_pos;
uniform vec3 u_sun_dir;
uniform vec3 u_sun_color;
uniform vec3 u_light_ambient;

uniform float u_alpha;

varying vec4 v_light;
varying vec2 v_texCoord;

void main()
{
  int i = int(a_quad_data[3]);
  vec2 info = a_particle_info.xy / 255.0;

  vec3 p = a_quad_data.xyz;
  float density = 2.9 * info[0];
  vec4 q = density * u_billboard * vec4(u_quad_coord[i], 1.0);
  
  vec3 eye = u_eye_pos;
  vec3 sun = u_sun_dir;
  
  float a = 0.3 * abs(dot(normalize(eye - p), sun));

  float cloud_light = info.y;

  vec4 amb = vec4(u_light_ambient, density+3.0*a);
  v_light = 0.3 * amb;
  v_light += (0.6 + a) * cloud_light * vec4(u_sun_color, 1.0);
  v_light.a *= u_alpha;

  v_texCoord = u_quad_tex[i];
  gl_Position = (u_viewProj * (vec4(p+q.xyz, 1.0)));
}
