/**************************************************************************
 * 
 * Copyright (C) 2011 Nena Innovation AB. All rights reserved.
 * 
 **************************************************************************/


attribute vec4 a_quad_data;
attribute vec4 a_particle_info;

uniform mat4 u_viewProj;
uniform mat4 u_billboard;
uniform vec3 u_quad_coord[4];
uniform vec2 u_quad_tex[4];

uniform vec3 u_eye_pos;
uniform vec3 u_sun_dir;

varying vec4 v_light;
varying vec2 v_texCoord;

void main()
{
  int i = int(a_quad_data[3]);
  vec4 info = a_particle_info / 255.0;

  vec3 p = a_quad_data.xyz;
  float density = 1.3*info[0]; // clamp(0.2 * info[0], 0.01, 4.0);
  vec4 q = density * u_billboard * vec4(u_quad_coord[i], 1.0);

  vec3 eye = u_eye_pos;
  vec3 sun = u_sun_dir;

  float a = 0.5+0.5*abs(dot(normalize(eye - p), sun));
  
  v_light = a * vec4(vec3(0.5,0.5,0.5)+0.5*a_particle_info.yzw, 1.0);

  v_texCoord = u_quad_tex[i];
  gl_Position = (u_viewProj * (vec4(p+q.xyz, 1.0)));
}
