/**************************************************************************
 * 
 * Copyright (C) 2011 Nena Innovation AB. All rights reserved.
 * 
 **************************************************************************/


attribute vec3 a_vertex;
attribute vec2 a_texCoord;
attribute float a_offset;

uniform mat4 u_view;
uniform mat4 u_viewProj;
uniform vec3 u_lightPos;
uniform vec3 u_side;

varying vec2 v_texCoord;
varying float v_lightskew;
varying float v_offset;

void main()
{
  v_texCoord = a_texCoord;
  vec4 v = vec4(a_vertex, 1.0);
  vec4 p = u_view * v;
  v_lightskew = dot(u_side, normalize(u_lightPos - p.xyz));
  v_offset = a_offset;
  gl_Position = u_viewProj * v;
}
