/**************************************************************************
 * 
 * Copyright (C) 2011 Nena Innovation AB. All rights reserved.
 * 
 **************************************************************************/


attribute vec3 a_vertex;
attribute vec3 a_normal;

uniform mat4 u_viewProj;
uniform vec3 u_light_pos;
uniform vec4 u_ambient_color;
uniform vec4 u_diffuse_color;

varying vec4 v_color;

void main()
{
  float c = max(0.0, dot(a_normal, normalize(u_light_pos - a_vertex)));
  v_color = mix(u_ambient_color, u_diffuse_color, c);
  gl_Position = u_viewProj * vec4(a_vertex, 1.0);
}
