/**************************************************************************
 * 
 * Copyright (C) 2011 Nena Innovation AB. All rights reserved.
 * 
 **************************************************************************/

// Renders the sky, smoothly blending horizon and zenith colors.

uniform mat4 u_viewProj;
uniform vec3 u_zenithColor;
uniform vec3 u_horizonColor;
uniform float u_horizonLimit;
uniform vec2 u_texDelta;
uniform float u_colWeight;


attribute vec3 a_vertex;
attribute vec2 a_texcoord;

varying vec2 v_texCoord;
varying vec3 v_color;

void main()
{
  v_texCoord = (a_texcoord+u_texDelta);  
  float sp = smoothstep(0.0, u_horizonLimit, a_vertex.z);
  v_color = u_colWeight*(sp*u_zenithColor + (1.0-sp)*u_horizonColor);
  
  gl_Position = u_viewProj * vec4(a_vertex, 1.0);
}