/**************************************************************************
 * 
 * Copyright (C) 2011 Nena Innovation AB. All rights reserved.
 * 
 **************************************************************************/

// Bumpmap shader for walls on the house.

#ifdef GL_ES
precision mediump float;
#endif

uniform sampler2D u_sampler;
uniform sampler2D u_sampler2;

uniform vec3 u_lightCol;
uniform vec2 u_lightMod;

varying vec2 v_texCoord;
varying vec3 v_lightVec;

void main()
{  
  vec3 normal = (2.0*normalize(texture2D(u_sampler2, v_texCoord).xyz)) - vec3(1.0, 1.0, 1.0);
  float lambert = max (dot(v_lightVec, normal), 0.0);
  
  vec3 base_color = texture2D(u_sampler, v_texCoord).xyz;
   
  if(lambert > 0.0) {
    vec3 light = (u_lightMod[0]+u_lightMod[1]*lambert)*u_lightCol;
    gl_FragColor = vec4(light*base_color, 1.0);
  } else {
    gl_FragColor = vec4(u_lightMod[0]*base_color*u_lightCol, 1.0);
  }
  
}
