/**************************************************************************
 * 
 * Copyright (C) 2011 Nena Innovation AB. All rights reserved.
 * 
 **************************************************************************/

// Bumpmap shader. Not using spec highlight, skipping half vector.

uniform mat4 u_viewProj;
uniform mat4 u_model;
uniform vec3 u_lightPos;

attribute vec3 a_vertex;
attribute vec3 a_normal;
attribute vec2 a_texcoord;
attribute vec3 a_tangent;

varying vec2 v_texCoord;
varying vec3 v_lightVec;

void main()
{
  vec4 w_pos = u_model*vec4(a_vertex, 1.0);
    
  // tangent space matrix
	vec3 n = normalize (u_model * vec4(a_normal, 0.0)).xyz;
	vec3 t = normalize (u_model * vec4(normalize(a_tangent), 0.0)).xyz;
	vec3 b = cross (n, t);  

	// Transform lightvec into tangent space
  vec3 lightDir = normalize(u_lightPos - w_pos.xyz);
	vec3 v;
	v.x = dot(lightDir, t);
	v.y = dot(lightDir, b);
	v.z = dot(lightDir, n);
	v_lightVec = normalize (v);  
  
  v_texCoord = a_texcoord;
  gl_Position = u_viewProj * vec4(a_vertex, 1.0);
}
