/**************************************************************************
 * 
 * Copyright (C) 2011 Nena Innovation AB. All rights reserved.
 * 
 **************************************************************************/

// Reflection shader for windows.

uniform mat4 u_viewProj;
uniform mat4 u_model;
uniform vec3 u_lightPos;
uniform vec3 u_eyePos;
uniform vec3 u_lightCol;
uniform vec2 u_lightMod;

attribute vec3 a_vertex;
attribute vec3 a_normal;
attribute vec2 a_texcoord;

varying vec3 v_light;
varying vec3 v_normal;

const vec3 c_inside = vec3(0.2, 0.2, 0.3);

void main()
{
  vec4 w_pos = u_model*vec4(a_vertex, 1.0);
  vec4 w_nor = u_model*vec4(a_normal, 0.0); 

  vec3 lightdir = normalize(u_lightPos - w_pos.xyz);
  float diff = max(0.0, dot(lightdir, w_nor.xyz));
  vec3 eyedir = normalize(u_eyePos - w_pos.xyz);
  vec3 refl = reflect(-eyedir, w_nor.xyz);

  v_light = c_inside+vec3(u_lightMod[0]+u_lightMod[1]*diff);
  v_normal =  refl;
  gl_Position = u_viewProj * vec4(a_vertex, 1.0);
}
