/**************************************************************************
 * 
 * Copyright (C) 2011 Nena Innovation AB. All rights reserved.
 * 
 **************************************************************************/


attribute float a_param;

uniform mat4 u_modelViewMatrix;
uniform mat4 u_modelViewProjectionMatrix;
uniform mat4 u_object;
uniform vec3 u_wind;
uniform vec3 u_gravity;
uniform vec3 u_lightDir;
uniform vec4 u_color;
uniform vec3 u_side;

varying vec4 v_color;

vec3 calc(float t, vec3 r0, vec3 v0, vec3 g, vec3 wind)
{
  vec3 a = g + wind;
  return r0 + v0*t + 0.5 * a * t*t;
}

void main()
{
  vec3 origin  = (u_object * vec4(0.0, 0.0, 0.0, 1.0)).xyz;
  vec3 v0 = (u_object * vec4(0.0, 0.0, -1.0, 0.0)).xyz;

  float v = a_param;

  vec3 pos  = calc(v, origin, 3.0*v0, u_gravity, u_wind);
  vec3 n = (u_modelViewMatrix * vec4(pos - origin, 0.0)).xyz;
  normalize(n);
  float light = 0.6 * max(0.0, dot(n, u_lightDir));
  v_color = light * vec4(1.0, 0.4, 0.2, 1.0) + u_color;

  float offset = mod(v, 0.4);
  pos +=  offset * u_side;

  gl_Position = u_modelViewProjectionMatrix * vec4(pos, 1.0);
}
