/**************************************************************************
 * 
 * Copyright (C) 2011 Nena Innovation AB. All rights reserved.
 * 
 **************************************************************************/


uniform mat4 u_viewProj;
uniform mat4 u_model;
uniform vec3 u_lightPos;

attribute vec3 a_vertex;
attribute vec3 a_normal;
attribute vec2 a_texcoord;

varying float v_light;
varying vec2 v_texCoord;

void main()
{
  vec4 w_pos = u_model*vec4(a_vertex, 1.0);
  vec4 w_nor = u_model*vec4(a_normal, 0.0); 

  vec3 lightdir = normalize(u_lightPos - w_pos.xyz);
  float diff = max(0.0, dot(lightdir, w_nor.xyz));

  v_texCoord = a_texcoord;
  v_light = diff;
  gl_Position = u_viewProj * vec4(a_vertex, 1.0);
}
