/**************************************************************************
 * 
 * Copyright (C) 2011 Nena Innovation AB. All rights reserved.
 * 
 **************************************************************************/


attribute vec4 a_param;
attribute float a_index;

uniform float u_time;
uniform mat4 u_modelViewProjectionMatrix;
uniform vec3 u_triCoord[3];
uniform vec2 u_triTex[3];

varying float v_age;
varying vec2 v_texCoord;

void main()
{
  int ix = int(a_index);
  vec3 pos;
  pos = u_triCoord[ix];
  float age = mod(max(0.0, u_time - a_param[0]), 3.0);
  pos.z += age;
  pos *= 3.0*age;
  float age_div = age /3.0;
  pos.y += age_div * (a_param[1]);
  pos.x += age_div * (a_param[2]);
  v_age = 1.0 - age_div;
  v_texCoord = u_triTex[ix];
  gl_Position = u_modelViewProjectionMatrix * vec4(pos, 1.0);
  gl_Position.z -= a_param[3];
}


