/**************************************************************************
 * 
 * Copyright (C) 2011 Nena Innovation AB. All rights reserved.
 * 
 **************************************************************************/

#ifdef GL_ES
precision mediump float;
#endif

uniform sampler2D u_samplerRock;
uniform sampler2D u_samplerGrass;
uniform sampler2D u_samplerSnow;

varying vec2 v_texCoord;
varying vec4 v_packed; // x: light, y: rocky, z: snowy, w: grassy

varying vec3 v_lightCol;

void main()
{
  // Fetch texels
 	vec3 texcol = vec3(texture2D(u_samplerGrass, v_texCoord.st));
  vec3 detcol = vec3(texture2D(u_samplerRock, v_texCoord.st));
  vec3 snocol = vec3(texture2D(u_samplerSnow, v_texCoord.st));
  
  gl_FragColor = vec4((texcol*v_packed.w+detcol*v_packed.y+snocol*v_packed.z)*v_lightCol, 1.0);
}
