/**************************************************************************
 * 
 * Copyright (C) 2011 Nena Innovation AB. All rights reserved.
 * 
 **************************************************************************/

#ifdef GL_ES
precision mediump float;
#endif

uniform sampler2D u_rockyTex;
uniform sampler2D u_grassTex;

varying vec2 v_texCoord;
varying vec4 v_packed; // x: light, y: rocky, z: snowy, w: grassy


const vec3 c_snocol = vec3(1.0, 1.0, 1.0);

void main()
{
  // Fetch texels
 	vec3 texcol = vec3(texture2D(u_grassTex, v_texCoord.st));
  vec3 detcol = vec3(texture2D(u_rockyTex, v_texCoord.st));
  
  gl_FragColor = vec4((texcol*v_packed.w+detcol*v_packed.y+c_snocol*v_packed.z)*v_packed.x, 1.0);
}
