/**************************************************************************
 * 
 * Copyright (C) 2011 Nena Innovation AB. All rights reserved.
 * 
 **************************************************************************/

uniform mat4 u_modelViewProjectionMatrix;

attribute vec3 a_vertex;
attribute vec2 a_texCoord;
attribute vec3 a_texBlend;
attribute vec2 a_light;

varying vec2 v_texCoord;
varying vec4 v_packed; // x: light, y: rocky, z: snowy, w: grassy


void main()
{
	gl_Position = u_modelViewProjectionMatrix * vec4(a_vertex, 1.0);
  v_texCoord = a_texCoord.st;

  // Light is pre-computed
  v_packed.x =  a_light.x;

  // Texture blend parameter setup
  v_packed.y =  a_texBlend.y;
  v_packed.z =  a_texBlend.z;
  v_packed.w =  a_texBlend.x;    
}
