/**************************************************************************
 * 
 * Copyright (C) 2011 Nena Innovation AB. All rights reserved.
 * 
 **************************************************************************/

#ifdef GL_ES
precision mediump float;
#endif

uniform sampler2D u_rockyTex;
uniform sampler2D u_grassTex;
uniform sampler2D u_shadowTex;

varying vec2 v_texCoord;
varying float v_rocky;
varying float v_snowy;
varying float v_grassy;
varying float v_lightIntensity;
varying vec4 v_shadowCoord;

const vec3 c_snocol = vec3(1.0, 1.0, 1.0);

void main()
{

  // Fetch texels
 	vec3 texcol = vec3(texture2D(u_grassTex, v_texCoord.st));
  vec3 detcol = vec3(texture2D(u_rockyTex, v_texCoord.st));
  
  float light_z = texture2D(u_shadowTex, v_shadowCoord.xy).x;
  float shadow = 1.0;
  if(v_shadowCoord.x > 0.1 && v_shadowCoord.x < 0.9 && v_shadowCoord.y < 0.9 && v_shadowCoord.y > 0.1)
    shadow = light_z < (v_shadowCoord.z-0.0001) ? 0.1 : 1.0;
  
  gl_FragColor = vec4((texcol*v_grassy+detcol*v_rocky+c_snocol*v_snowy)*v_lightIntensity*shadow, 1.0);
}
