/**************************************************************************
 * 
 * Copyright (C) 2011 Nena Innovation AB. All rights reserved.
 * 
 **************************************************************************/

uniform mat4 u_modelViewProjectionMatrix;
uniform mat4 u_shadowMatrix;

attribute vec3 a_vertex;
attribute vec3 a_normal;
attribute vec2 a_texCoord;
attribute vec3 a_texBlend;
attribute vec2 a_light;
attribute float a_clip;

varying float v_lightIntensity;
varying vec2 v_texCoord;
varying float v_rocky;
varying float v_snowy;
varying float v_grassy;
varying vec4 v_shadowCoord;


void main()
{
	gl_Position = u_modelViewProjectionMatrix * vec4(a_vertex, 1.0);
  v_texCoord = a_texCoord.st;

  // Texture blend parameter setup
  v_grassy = a_texBlend.x;
  v_rocky =  a_texBlend.y;
  v_snowy =  a_texBlend.z;
  
  // Light is pre-computed
  v_lightIntensity =  a_light.x;

  v_shadowCoord =  u_shadowMatrix * vec4(a_vertex, 1.0);
  v_shadowCoord = (v_shadowCoord / v_shadowCoord.w);
}