/**************************************************************************
 * 
 * Copyright (C) 2011 Nena Innovation AB. All rights reserved.
 * 
 **************************************************************************/

#ifdef GL_ES
precision mediump float;
#endif

uniform sampler2D u_rockyTex;
uniform sampler2D u_grassTex;
uniform sampler2D u_shadowTex;

varying vec2 v_texCoord;
varying float v_rocky;
varying float v_snowy;
varying float v_grassy;
varying float v_lightIntensity;
varying vec4 v_shadowCoord;
//varying float v_lightDepth;

const vec3 c_snocol = vec3(1.0, 1.0, 1.0);
const vec4 unpackf = vec4(1.0/(256.0*256.0*256.0), 1.0/(256.0*256.0), 1.0/256.0, 1.0);

void main()
{
  // Fetch texels
 	vec3 texcol = vec3(texture2D(u_grassTex, v_texCoord.st));
  vec3 detcol = vec3(texture2D(u_rockyTex, v_texCoord.st));
  
  // Shadows
  vec4 tval = texture2D(u_shadowTex, v_shadowCoord.xy);
  float light_z = dot(tval,unpackf);  
  float shadow = 1.0;
  if(v_shadowCoord.x > 0.01 && v_shadowCoord.x < 0.99 && v_shadowCoord.y < 0.99 && v_shadowCoord.y > 0.01)
    shadow = light_z < ((v_shadowCoord.z+1.0)/2.0) ? 0.1 : 1.0;

  // Final computation
  gl_FragColor = vec4((texcol*v_grassy+detcol*v_rocky+c_snocol*v_snowy)*v_lightIntensity*shadow, 1.0);
}
