/**************************************************************************
 * 
 * Copyright (C) 2011 Nena Innovation AB. All rights reserved.
 * 
 **************************************************************************/


#ifdef GL_ES
precision mediump float;
#endif

uniform sampler2D u_samplerRock;
uniform sampler2D u_samplerGrass;
uniform sampler2D u_samplerShadow;
uniform sampler2D u_samplerSnow;
uniform float u_shadowBlend;

varying vec2 v_texCoord;
varying float v_rocky;
varying float v_snowy;
varying float v_grassy;

varying vec4 v_shadowCoord;
varying vec3 v_lightCol;
varying float v_lightDepth;

const vec2 c_texscale = vec2(1.0/512.0);

void main()
{
  // Fetch texels
 	vec3 texcol = vec3(texture2D(u_samplerGrass, v_texCoord.st));
  vec3 detcol = vec3(texture2D(u_samplerRock, v_texCoord.st));
  vec3 snocol = vec3(texture2D(u_samplerSnow, v_texCoord.st));
  float shadow = texture2DProj(u_samplerShadow, v_shadowCoord).x<v_lightDepth?u_shadowBlend:1.0;
  
  gl_FragColor = vec4((texcol*v_grassy+detcol*v_rocky+snocol*v_snowy)*v_lightCol*shadow, 1.0);
}
