/**************************************************************************
 * 
 * Copyright (C) 2011 Nena Innovation AB. All rights reserved.
 * 
 **************************************************************************/


uniform mat4 u_viewProj;
uniform mat4 u_shadow;
uniform vec3 u_lightPos;
uniform vec3 u_lightCol;
uniform vec2 u_lightMod;

attribute vec3 a_vertex;
attribute vec3 a_normal;
attribute vec2 a_texCoord;
attribute vec3 a_blend;
attribute vec2 a_light;
attribute float a_clip;

varying vec2 v_texCoord;

varying float v_rocky;
varying float v_snowy;
varying float v_grassy;

varying vec4 v_shadowCoord;
varying vec3 v_lightCol;

varying float v_lightDepth;

void main()
{
  vec3 w_pos = a_vertex;
  vec3 w_nor = a_normal; //Normals will always be in world coordinates
	gl_Position = u_viewProj * vec4(a_vertex, 1.0);
  v_texCoord = a_texCoord.st;
  
  vec3 lightdir = normalize(u_lightPos - w_pos);
  float diff = max(0.0, dot(lightdir, w_nor));
  
  v_lightCol = vec3(a_light.x, a_light.x, a_light.x);

  // Texture blend parameter setup
  v_grassy = a_blend.x;
  v_rocky =  a_blend.y;
  v_snowy =  a_blend.z;

  v_shadowCoord =  u_shadow * vec4(a_vertex, 1.0);
  v_lightDepth = ((v_shadowCoord.z/v_shadowCoord.w)+1.0)/2.0;
}
