/**************************************************************************
 * 
 * Copyright (C) 2011 Nena Innovation AB. All rights reserved.
 * 
 **************************************************************************/


uniform mat4 u_viewProj;
uniform vec3 u_lightPos;
uniform vec3 u_lightCol;
uniform vec2 u_lightMod;

attribute vec3 a_vertex;
attribute vec2 a_texCoord;
attribute vec3 a_blend;
attribute vec2 a_light;
attribute vec3 a_normal;

varying vec2 v_texCoord;
varying vec4 v_packed; // x: light, y: rocky, z: snowy, w: grassy

void main()
{
  vec3 w_pos = a_vertex;
  vec3 w_nor = a_normal; //Normals will always be in world coordinates
  vec3 lightdir = normalize(u_lightPos - w_pos);
  float diff = max(0.0, dot(lightdir, w_nor));
  
  vec3 lightCol = (u_lightMod[0]+u_lightMod[1]*diff)*u_lightCol;

	gl_Position = u_viewProj * vec4(a_vertex, 1.0);
  v_texCoord = a_texCoord.st;

  // Light is pre-computed
  v_packed.x =  a_light.x;

  // Texture blend parameter setup
  v_packed.y =  a_blend.y; // rocky
  v_packed.z =  a_blend.z; // snowy
  v_packed.w =  a_blend.x; // grassy
}
