/**************************************************************************
 * 
 * Copyright (C) 2011 Nena Innovation AB. All rights reserved.
 * 
 **************************************************************************/


#ifdef GL_ES
precision mediump float;
#endif

uniform sampler2D u_reflTex;
uniform sampler2D u_normTex;
uniform vec2 u_screenRes;

varying vec2 v_texCoord;

const float c_specularContribution = 0.3;
const float c_diffuseContribution = 0.6 - c_specularContribution;
const float c_bumpFactor = 0.35;

void main()
{
  // "Bump" part
  vec3 ntval = texture2D(u_normTex, v_texCoord).xyz;
  vec3 norm = ntval-0.5;

  // Reflection part
  vec2 nc = gl_FragCoord.xy*u_screenRes;
  nc += norm.xy*c_bumpFactor;
  vec3 base = vec3(texture2D(u_reflTex, nc.xy));
  gl_FragColor = vec4(base*(norm.z*c_specularContribution+c_diffuseContribution),0.65);  
}


