/**************************************************************************
 * 
 * Copyright (C) 2011 Nena Innovation AB. All rights reserved.
 * 
 **************************************************************************/


uniform mat4 u_modelViewProjectionMatrix;
uniform mat4 u_model;
uniform float u_anim;
uniform vec3 u_eyePos;
uniform vec3 u_lightPos;

attribute vec3 a_vertex;
attribute vec2 a_texCoord;
attribute vec3 a_tangent;
attribute vec3 a_normal;

varying vec2 v_texCoordWave;
varying vec2 v_texCoordMask;
varying vec3 v_eyeVec;

const float c_waveFreq = 3.0;

void main()
{
  vec3 w_pos = vec3(u_model*vec4(a_vertex, 1.0));
  
 	gl_Position = u_modelViewProjectionMatrix*vec4(a_vertex, 1.0);
  v_eyeVec = normalize(u_eyePos-w_pos);
  v_texCoordWave = c_waveFreq*a_texCoord.st+vec2(0.0, u_anim);
  v_texCoordMask = a_texCoord.st;
}


