/**************************************************************************
 * 
 * Copyright (C) 2011 Nena Innovation AB. All rights reserved.
 * 
 **************************************************************************/


#ifdef GL_ES
precision mediump float;
#endif

uniform sampler2D u_sampler;
varying vec2 v_texcoord;

const vec4 fpack = vec4(256.0*256.0*256.0, 256.0*256.0, 256.0, 1.0);
const vec4 modu = vec4(0.0, 1.0/256.0, 1.0/256.0, 1.0/256.0);

void main()
{
  vec4 col = texture2D(u_sampler, v_texcoord);
  if(col.a < 0.5) {
    discard;
  }
  
  float v = (gl_FragCoord.z + 1.0) / 2.0;
  vec4 pv = vec4(fract(fpack*v));
  pv -= pv.xxyz * modu;
  
  gl_FragColor  = pv;
}
